import 'package:ef/ef.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';
import 'package:vbvs_app/common/color/appConstants.dart';
import 'package:vbvs_app/common/util/FitTool.dart';
import 'package:vbvs_app/common/util/MyUtils.dart';
import 'package:vbvs_app/component/tool/ClickableContainer.dart';
import 'package:vbvs_app/pages/device_bind/componnet/bind_dialog.dart';
import 'package:vbvs_app/pages/sleep_report/chart/LineChartByRange.dart';
import 'package:EasyDartModule/EasyDartModule.dart' as es;

class BreathePauseNewWidget extends StatefulWidget {
  var sleepReport;
  BreathePauseNewWidget({super.key, required this.sleepReport});

  @override
  State<BreathePauseNewWidget> createState() => _SnoreViewWidgetWidgetState();
}

class _SnoreViewWidgetWidgetState extends State<BreathePauseNewWidget> {
  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    try {
      if (widget.sleepReport == null ||
          widget.sleepReport is! Map ||
          widget.sleepReport.isEmpty) {
        return Container();
      }

      List standard = widget.sleepReport['brs'] ?? [];
      final Map? result = standard.cast<Map>().firstWhere(
            (element) => element['id'] == 302,
            orElse: () => <dynamic, dynamic>{},
          );

      int threshold = 0;
      if (result != null && result.isNotEmpty) {
        final rangeValue = result['range'];
        if (rangeValue is int) {
          threshold = rangeValue;
        } else if (rangeValue is String) {
          threshold = int.tryParse(rangeValue) ?? 0;
        }
      }

      List<Map<String, dynamic>> data =
          (widget.sleepReport['asp'] as List).cast<Map<String, dynamic>>();
      List<Map<String, dynamic>> showLabel = convertToShowLabel(data);
      var startTime = widget.sleepReport['startTime'];
      var endTime = widget.sleepReport['endTime'];
      return Container(
        width: double.infinity,
        decoration: BoxDecoration(
          color: themeController.currentColor.sc5,
          borderRadius: BorderRadius.circular(
              AppConstants().normal_container_radius), // 你可以按需调整圆角半径
        ),
        child: Padding(
          padding:
              EdgeInsetsDirectional.fromSTEB(26.rpx, 29.rpx, 26.rpx, 0.rpx),
          child: Column(
            mainAxisSize: MainAxisSize.max,
            children: [
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text(
                      "呼吸暂停监测".tr,
                      style: TextStyle(
                          color: themeController.currentColor.sc3,
                          fontSize: AppConstants().title_text_fontSize),
                    ),
                    ClickableContainer(
                      backgroundColor: Colors.transparent,
                      highlightColor: Colors.white, // 或设置为你需要的水波纹颜色
                      padding: EdgeInsetsDirectional.fromSTEB(
                          14.rpx, 0.rpx, 14.rpx, 0), //
                      borderRadius: 0.rpx, // 圆形点击区域
                      onTap: () {
                        showTipDialog(
                          context,
                          Container(
                            child: Text(
                              "呼吸暂停监测介绍。",
                              style: TextStyle(
                                fontSize: 26.rpx,
                                color: themeController.currentColor.sc3,
                              ),
                            ),
                          ),
                        );
                      },
                      child: Container(
                        padding: EdgeInsetsDirectional.fromSTEB(
                            0, 0.rpx, 0.rpx, 0), // 外部 padding 移到内部
                        width: 28.rpx,
                        height: 28.rpx,
                        child: SvgPicture.asset(
                          'assets/img/icon/explain.svg',
                          fit: BoxFit.cover,
                          color: themeController.currentColor.sc4,
                        ),
                      ),
                    ),
                  ],
                ),
              ),
              SizedBox(
                height: 32.rpx,
              ),
              Row(
                children: [
                  Text(
                    "秒".tr,
                    style: TextStyle(
                        color: stringToColor("#FFFFFF"), fontSize: 18.rpx),
                  ),
                ],
              ),
              Padding(
                padding:
                    EdgeInsetsDirectional.fromSTEB(0.rpx, 40.rpx, 0.rpx, 0.rpx),
                child: LineChartByRange(
                  showLabel: showLabel,
                  startTime: startTime,
                  endTime: endTime,
                  threshold: threshold != 0 ? threshold : null,
                  maxY: threshold == 0 ? threshold + 10 : 70,
                  ySegments: 7,
                ),
              ),
              SizedBox(
                height: 52.rpx,
              ),
            ],
          ),
        ),
      );
    } catch (e) {
      es.EasyDartModule.logger.error("打鼾监测绘制异常${e}");
      return Container();
    }
  }

  List<Map<String, dynamic>> convertToShowLabel(
      List<Map<String, dynamic>> data) {
    if (data.isEmpty) return [];

    data.sort((a, b) => a['st'].compareTo(b['st'])); // 确保时间有序

    List<Map<String, dynamic>> result = [];

    int startTime = data[0]['st'];
    int endTime = data[0]['st'];
    int currentValue = data[0]['value'];

    for (int i = 1; i < data.length; i++) {
      final item = data[i];
      final st = item['st'];
      final value = item['value'];

      if (value == currentValue) {
        endTime = st;
      } else {
        result.add({
          "startTime": startTime,
          "endTime": endTime,
          "times": currentValue,
        });
        startTime = st;
        endTime = st;
        currentValue = value;
      }
    }

    // 添加最后一段
    result.add({
      "startTime": startTime,
      "endTime": endTime,
      "times": currentValue,
    });

    return result;
  }
}
